/* Svaka funkcija je implementirana na dva načina. Ovo na kolokviju nije potrebno;
   dovoljna je jedna verzija svake funkcije.
   Funkcijama su dani nazivi oblika zad_grupa_podzadatak_rjesenje(). Npr. zad_1_b_2()
   je drugo rješenje podzadatka b) u prvoj grupi. Na kolokviju, zadaju se imena
   kakva pisu u samim zadacima. Ovdje time zaobilazimo koliziju funkcijama jednakog
   imena iz razlicitih grupa, kao i koliziju s funkcijama iz string.h koje
   implementiramo u podzadatku a), a koristimo u podzadacima b) i c). */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define probaj_alternativno_rjesenje 1

#define OUT1(msg, s) printf("  %s poziva funkcije: s = \"%s\"\n", msg, s);
#define OUT2(msg, s1, s2) printf("  %s poziva funkcije: s1 = \"%s\", s2 = \"%s\"\n", msg, s1, s2);
#define HEADZ(group) printf("Grupa %d:\n", group);
#define TEST1(group, prog, len1) \
  { \
    char s1[len1] = "Pero", s2[] = " Sapun"; \
    if (group > 0) HEADZ(group) \
    printf("  a) %s rjesenje:\n", group < 0 ? "Drugo" : "Prvo"); \
    OUT2("     Prije", s1, s2) \
    prog(s1, s2); \
    OUT2("     Nakon", s1, s2) \
  }
#define TEST3(group, prog) \
  { \
    char s[] = "Pero"; \
    if (group > 0) HEADZ(group) \
    printf("  a) %s rjesenje:\n", group < 0 ? "Drugo" : "Prvo"); \
    OUT1("     Prije", s) \
    printf("       Duljina stringa s je %d\n", prog(s)); \
  }
#define TEST4(group, prog) \
  { \
    char s1[] = "Pero", s2[] = "Sapun"; \
    if (group > 0) HEADZ(group) \
    printf("  a) %s rjesenje:\n", group < 0 ? "Drugo" : "Prvo"); \
    printf("     s1 = \"%s\", s2 = \"%s\"\n", s1, s2); \
    printf("     strcmp(s1, s2) = %d, strcmp(s1, s1) = %d, strcmp(s2, s1) = %d\n", prog(s1, s2), prog(s1, s1), prog(s2, s1)); \
  }


/* Grupa 1 */

char* zad_1_a_1(char *s1, const char *s2) {
  int i;
  for (i = 0; s2[i]; ++i) s1[i] = s2[i];
  s1[i] = '\0';
  return s1;
}

char* zad_1_a_2(char *s1, const char *s2) {
  char *r = s1;
  while (*s1++ = *s2++);
  return r;
}

char *zad_1_b_1(const char *s, int n) {
  char *out = (char*)malloc((strlen(s) * n + 1) * sizeof(char));
  int i;
  out[0] = '\0';
  for (i = 0; i < n; ++i) strcat(out, s);
  return out;
}

char *zad_1_b_2(const char *s, int n) {
  char *out = (char*)malloc((strlen(s) * n + 1) * sizeof(char));
  strcpy(out, s);
  while (--n) strcat(out, s);
  return out;
}

/* Grupa 2 */

char* zad_2_a_1(char *s1, const char *s2) {
  int i, j;
  for (i = 0; s1[i]; ++i);
  for (j = 0; s2[j]; ++j) s1[i++] = s2[j];
  s1[i] = '\0';
  return s1;
}

char* zad_2_a_2(char *s1, const char *s2) {
  char *r = s1;
  while (*s1) ++s1;
  while (*s1++ = *s2++);
  return r;
}

char *zad_2_b_1(const char *s, int n) {
  char *out;
  int k = 0, len = strlen(s), i;
  while (k * len < n) ++k;
  out = (char*)malloc((k * len + 1) * sizeof(char));
  out[0] = '\0';
  for (i = 0; i < k; ++i) strcat(out, s);
  return out;
}

char *zad_2_b_2(const char *s, int n) {
  char *out;
  int len = strlen(s);
  while (n % len) ++n;
  out = (char*)malloc((n + 1) * sizeof(char));
  strcpy(out, s);
  while (n -= len) strcat(out, s);
  return out;
}

/* Grupa 3 */

int zad_3_a_1(const char *s) {
  int i;
  for (i = 0; s[i]; ++i);
  return i;
}

int zad_3_a_2(const char *s) {
  const char *r = s;
  while (*s++);
  return s - r - 1;
}

char *zad_3_b_1(const char *s, int n) {
  char *out;
  int i, j = 0, lens = strlen(s), len = 0;
  for (i = 0; i < lens; ++i)
    if (i % n == 0) ++len;
  out = (char*)malloc((len + 1) * sizeof(char));
  for (i = 0; i < lens; i += n) out[j++] = s[i];
  out[j] = '\0';
  return out;
}

char *zad_3_b_2(const char *s, int n) {
  char *out;
  int i, len = (strlen(s) - 1) / n + 1;
  out = (char*)malloc((len + 1) * sizeof(char));
  for (i = 0; i < len; ++i) out[i] = s[i * n];
  out[len] = '\0';
  return out;
}

/* Grupa 4 */

int zad_4_a_1(const char *s1, const char *s2) {
  int i;
  for (i = 0; s1[i] != '\0' && s2[i] != '\0'; ++i)
    if (s1[i] < s2[i]) return -1; else
    if (s1[i] > s2[i]) return 1;
  if (s1[i] < s2[i]) return -1;
  if (s1[i] > s2[i]) return 1;
  return 0;
}

int zad_4_a_2(const char *s1, const char *s2) {
  while (*s1 && *s2) ++s1, ++s2;
  return *s1 - *s2 ? *s1 < *s2 ? -1 : 1 : 0;
}

char *zad_4_b_1(const char *s1, const char *s2) {
  char *out = (char*)malloc((strlen(s1) + strlen(s2) + 1) * sizeof(char));
  if (strcmp(s1, s2) > 0) {
    strcpy(out, s1);
    strcat(out, s2);
  } else {
    strcpy(out, s2);
    strcat(out, s1);
  }
  return out;
}

char *zad_4_b_2(const char *s1, const char *s2) {
  char *out = (char*)malloc((strlen(s1) + strlen(s2) + 1) * sizeof(char));
  *out = '\0';
  if (strcmp(s1, s2) > 0) {
    strcat(out, s1);
    strcat(out, s2);
  } else {
    strcat(out, s2);
    strcat(out, s1);
  }
  return out;
}

int main(void) {

  /* Grupa 1: */
  TEST1(1, zad_1_a_1, 7)
  TEST1(-1, zad_1_a_2, 7)
  {
    /* Podzadaci b) i c), prvo rjesenje */
    int n;
    char s1[76], *s2;
    printf("  c) Prvo rjesenje:\n");
    printf("       Unesite jedan broj: "); scanf("%d", &n);
    printf("       Unesite liniju teksta: "); scanf(" %[^\n]", s1);
    s2 = zad_1_b_1(s1, n);
    printf("       Povratna vrijednost funkcije: \"%s\"\n", s2);
    free(s2);
  }
  {
    /* Podzadaci b) i c), prvo rjesenje */
    int n;
    char s1[76], *s2;
    printf("     Drugo rjesenje:\n");
    printf("       Unesite jedan broj: "); scanf("%d", &n);
    printf("       Unesite liniju teksta: "); scanf(" %[^\n]", s1);
    s2 = zad_1_b_2(s1, n);
    printf("       Povratna vrijednost funkcije: \"%s\"\n", s2);
    free(s2);
  }

  /* Grupa 2: */
  TEST1(2, zad_2_a_1, 11)
  TEST1(-2, zad_2_a_2, 11)
  {
    /* Podzadaci b) i c), prvo rjesenje */
    int n;
    char s1[58], *s2;
    printf("  c) Prvo rjesenje:\n");
    printf("       Unesite jedan broj: "); scanf("%d", &n);
    printf("       Unesite liniju teksta: "); scanf(" %[^\n]", s1);
    s2 = zad_2_b_1(s1, n);
    printf("       Povratna vrijednost funkcije: \"%s\"\n", s2);
    free(s2);
  }
  {
    /* Podzadaci b) i c), prvo rjesenje */
    int n;
    char s1[58], *s2;
    printf("     Drugo rjesenje:\n");
    printf("       Unesite jedan broj: "); scanf("%d", &n);
    printf("       Unesite liniju teksta: "); scanf(" %[^\n]", s1);
    s2 = zad_2_b_2(s1, n);
    printf("       Povratna vrijednost funkcije: \"%s\"\n", s2);
    free(s2);
  }

  /* Grupa 3: */
  TEST3(3, zad_3_a_1)
  TEST3(-3, zad_3_a_2)
  {
    /* Podzadaci b) i c), prvo rjesenje */
    int n;
    char s1[1720], *s2;
    printf("  c) Prvo rjesenje:\n");
    printf("       Unesite jedan broj: "); scanf("%d", &n);
    printf("       Unesite liniju teksta: "); scanf(" %[^\n]", s1);
    s2 = zad_3_b_1(s1, n);
    printf("       Povratna vrijednost funkcije: \"%s\"\n", s2);
    free(s2);
  }
  {
    /* Podzadaci b) i c), prvo rjesenje */
    int n;
    char s1[1720], *s2;
    printf("     Drugo rjesenje:\n");
    printf("       Unesite jedan broj: "); scanf("%d", &n);
    printf("       Unesite liniju teksta: "); scanf(" %[^\n]", s1);
    s2 = zad_3_b_2(s1, n);
    printf("       Povratna vrijednost funkcije: \"%s\"\n", s2);
    free(s2);
  }

  /* Grupa 3: */
  TEST4(4, zad_4_a_1)
  TEST4(-4, zad_4_a_2)
  {
    /* Podzadaci b) i c), prvo rjesenje */
    int n;
    char s1[1318], s2[1318], *s3;
    printf("  c) Prvo rjesenje:\n");
    printf("       Unesite liniju teksta: "); scanf(" %[^\n]", s1);
    printf("       Unesite liniju teksta: "); scanf(" %[^\n]", s2);
    s3 = zad_4_b_1(s1, s2);
    printf("       Povratna vrijednost funkcije: \"%s\"\n", s3);
    free(s3);
  }
  {
    /* Podzadaci b) i c), prvo rjesenje */
    int n;
    char s1[1318], s2[1318], *s3;
    printf("     Drugo rjesenje:\n");
    printf("       Unesite liniju teksta: "); scanf(" %[^\n]", s1);
    printf("       Unesite liniju teksta: "); scanf(" %[^\n]", s2);
    s3 = zad_4_b_2(s1, s2);
    printf("       Povratna vrijednost funkcije: \"%s\"\n", s3);
    free(s3);
  }

  return 0;
}
