#include <stdio.h>
#include <math.h>

/* Zbog koristenja math.h, pod Linuxom se ovo compilira s dodatnim parametrom -lm */

#define PI acos(-1)

typedef struct {
  double x, y, a, b;
} elipsa;

double zad3b(elipsa e) {
  return PI * e.a * e.b;
}

void zad3c(elipsa *e) {
  double tmp = e->a;
  e->a = e->b;
  e->b = tmp;
}

void zad3d(elipsa e[], int n) {
  int i, j;
  for (i = 0; i < n; ++i)
    for (j = i + 1; j < n; ++j)
      if (zad3b(e[i]) < zad3b(e[j])) {
        elipsa tmp = e[i];
        e[i] = e[j];
        e[j] = tmp;
      }
}

void ispis_elipse(elipsa e) {
  printf("[(%g,%g),%g,%g]", e.x, e.y, e.a, e.b);
}

void ispis_niza(elipsa e[], int n) {
  int i;
  for (i = 0; i < n; ++i) {
    printf("  %d: ", i+1);
    ispis_elipse(e[i]);
    printf("\t%g\n", zad3b(e[i]));
  }
}

int main(void) {
  elipsa e = {2.0, 17.0, 5.0/PI, 3.0}; /* povrsina je pi * 5/pi * 3 = 15 */
  elipsa niz[] = {{-31.0, -2.0, 29.0, 13.0}, e, {0.0, 5.0, 7.0, 29.0}, {4.0, -5.0, 1.0, 7.0}};
  int n = sizeof(niz) / sizeof(elipsa);

  printf("Prije rotacije:\n");
  printf("  e = "); ispis_elipse(e); printf(", P(e) = %g\n", zad3b(e));
  zad3c(&e);
  printf("Nakon rotacije:\n");
  printf("  e = "); ispis_elipse(e); printf(", P(e) = %g\n", zad3b(e));

  printf("Niz prije sorta:\n");
  ispis_niza(niz, n);
  zad3d(niz, n);
  printf("Niz nakon sorta:\n");
  ispis_niza(niz, n);

  return 0;
}
